package co.com.certicamara.utils;

import org.apache.log4j.Logger;
import org.springframework.stereotype.Component;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import java.io.StringWriter;

@Component
public class UtilsXML {

	private final Logger logger = Logger.getLogger(this.getClass());

	public String generarSoapCertificados(String username, String password, String nuip)
			throws ParserConfigurationException {
		logger.info("generando xml para el nuip: " + nuip);

		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		DocumentBuilder db = dbf.newDocumentBuilder();
		Document doc = db.newDocument();

		Element envelope = doc.createElementNS("http://schemas.xmlsoap.org/soap/envelope/", "soapenv:Envelope");
		envelope.setAttribute("xmlns:soapenv", "http://schemas.xmlsoap.org/soap/envelope/");
		envelope.setAttribute("xmlns:tws", "http://www.safelayer.com/TWS");
		doc.appendChild(envelope);

		Element header = doc.createElement("soapenv:Header");
		envelope.appendChild(header);

		Element security = doc.createElement("wsse:Security");
		security.setAttribute("xmlns:wsse",
				"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd");
		security.setAttribute("soapenv:actor", "http://schemas.xmlsoap.org/soap/actor/next");
		security.setAttribute("soapenv:mustUnderstand", "1");
		header.appendChild(security);

		Element usernameToken = doc.createElement("wsse:UsernameToken");
		security.appendChild(usernameToken);

		Element usernameElem = doc.createElement("wsse:Username");
		usernameElem.appendChild(doc.createTextNode(username));
		usernameToken.appendChild(usernameElem);

		Element passwordElem = doc.createElement("wsse:Password");
		passwordElem.setAttribute("Type",
				"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-username-token-profile-1.0#PasswordDigest");
		passwordElem.appendChild(doc.createTextNode(password));
		usernameToken.appendChild(passwordElem);

		Element body = doc.createElement("soapenv:Body");
		envelope.appendChild(body);

		Element readRequest = doc.createElement("tws:ReadRequest");
		readRequest.setAttribute("xpath", "/TWS/EP/PU/User[SName/UID='" + nuip + "']");

		Element startAt = doc.createElement("tws:startAt");
		startAt.appendChild(doc.createTextNode("1"));
		readRequest.appendChild(startAt);

		Element nextElements = doc.createElement("tws:nextElements");
		nextElements.appendChild(doc.createTextNode("100"));
		readRequest.appendChild(nextElements);

		body.appendChild(readRequest);
		logger.info("xml generado para el nuip: " + nuip);
		return documentoToString(doc);
	}

	public String generarSoapValidarUsuario(String username, String password, String nuip)
			throws ParserConfigurationException {

		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		DocumentBuilder db = dbf.newDocumentBuilder();
		Document doc = db.newDocument();

		Element envelope = doc.createElementNS("http://schemas.xmlsoap.org/soap/envelope/", "soapenv:Envelope");
		envelope.setAttribute("xmlns:soapenv", "http://schemas.xmlsoap.org/soap/envelope/");
		envelope.setAttribute("xmlns:tws", "http://www.safelayer.com/TWS");
		doc.appendChild(envelope);

		Element header = doc.createElement("soapenv:Header");
		envelope.appendChild(header);

		Element security = doc.createElement("wsse:Security");
		security.setAttribute("xmlns:wsse",
				"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd");
		security.setAttribute("soapenv:actor", "http://schemas.xmlsoap.org/soap/actor/next");
		security.setAttribute("soapenv:mustUnderstand", "1");
		header.appendChild(security);

		Element usernameToken = doc.createElement("wsse:UsernameToken");
		security.appendChild(usernameToken);

		Element usernameElem = doc.createElement("wsse:Username");
		usernameElem.appendChild(doc.createTextNode(username));
		usernameToken.appendChild(usernameElem);

		Element passwordElem = doc.createElement("wsse:Password");
		passwordElem.setAttribute("Type",
				"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-username-token-profile-1.0#PasswordDigest");
		passwordElem.appendChild(doc.createTextNode(password));
		usernameToken.appendChild(passwordElem);

		Element body = doc.createElement("soapenv:Body");
		envelope.appendChild(body);

		Element searchRequest = doc.createElement("tws:SearchRequest");
		searchRequest.setAttribute("xpath", "/TWS/EP/PU/User[SName/UID='" + nuip + "']");
		body.appendChild(searchRequest);

		return documentoToString(doc);

	}

	public String generarSoapValidarAutenticacion(String username, String password)
			throws ParserConfigurationException {
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		DocumentBuilder db = dbf.newDocumentBuilder();
		Document doc = db.newDocument();

		
		Element envelope = doc.createElementNS("http://schemas.xmlsoap.org/soap/envelope/", "SOAP-ENV:Envelope");
		envelope.setAttribute("xmlns:SOAP-ENV", "http://schemas.xmlsoap.org/soap/envelope/");
		doc.appendChild(envelope);

		
		Element header = doc.createElement("SOAP-ENV:Header");
		envelope.appendChild(header);

		Element security = doc.createElement("wsse:Security");
		security.setAttribute("xmlns:wsse",
				"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd");
		security.setAttribute("xmlns:wsu",
				"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd");
		header.appendChild(security);

		Element usernameToken = doc.createElement("wsse:UsernameToken");
		usernameToken.setAttribute("wsu:Id", "SecurityToken-VR0lBBYwFAYIKwYBB");
		security.appendChild(usernameToken);

		Element usernameElem = doc.createElement("wsse:Username");
		usernameElem.appendChild(doc.createTextNode(username));
		usernameToken.appendChild(usernameElem);

		Element passwordElem = doc.createElement("wsse:Password");
		passwordElem.setAttribute("Type",
				"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-username-token-profile-1.0#PasswordDigest");
		passwordElem.appendChild(doc.createTextNode(password));
		usernameToken.appendChild(passwordElem);

		Element body = doc.createElement("SOAP-ENV:Body");
		envelope.appendChild(body);

		Element authNRequest = doc.createElement("AuthNRequest");
		body.appendChild(authNRequest);

		Element direct = doc.createElement("direct");
		authNRequest.appendChild(direct);

		Element authPolicy = doc.createElement("tws:authPolicy");
		authPolicy.appendChild(doc.createTextNode("urn:safelayer:tws:policies:authentication:default:firmadigital"));
		direct.appendChild(authPolicy);

		Element respondWith = doc.createElement("respondWith");
		respondWith.appendChild(doc.createTextNode("saml:AssertionIDReference"));
		direct.appendChild(respondWith);
		return documentoToString(doc);

	}

	private String documentoToString(Document doc) {
		try {
			TransformerFactory transformerFactory = TransformerFactory.newInstance();
			Transformer transformer = transformerFactory.newTransformer();

			transformer.setOutputProperty("indent", "yes");
			StringWriter writer = new StringWriter();
			StreamResult result = new StreamResult(writer);
			DOMSource source = new DOMSource(doc);

			transformer.transform(source, result);

			return writer.toString();
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

}
